#!/bin/sh

if [ -z "$1" ] ; then
   echo "Usage: ./run.sh exec_out_name file ...CPP args" 
   exit -1
fi   
if [ -z "$2" ] ; then
   echo "Usage: ./run.sh exec_out_name file ...CPP args" 
   exit -1
fi   

file=$2
execn=$1
shift
shift
#WARNING: ensure that runtime.c is compiled with
#         the same debug flags
DEBUG_FLAG=`make -C runtime print_debug_flag`
rm -r -f tmp 
mkdir -p tmp/src 

#cat runtime/runtime.h $file > tmp/test0.c
#gcc $DEBUG_FLAG -E tmp/test0.c > tmp/test.c

echo "Processing file: $file"
echo "CPP options: $@"
gcc $@ $DEBUG_FLAG -include runtime/runtime.h -E $file > tmp/`basename $file`
echo "scripts/duppy tmp/`basename $file`" > gcc-log.txt

OCAMLRUNPARAM="b1" scripts/dump-calls.sh
OCAMLRUNPARAM="b1" ./deadlock.exe  -cg ciltrees/calls.cil $DEBUG

if [ $? -eq 0 ] ; then
    echo -e "Analysis [OK]\n"
#   grep -v "#line" ciltrees/src_pass2.c.txt > tmp/output.c 
   files=`ls -1 ciltrees/gen/ | awk '{printf "../ciltrees/gen/%s ", $0}' | sed 's/\.c/\.o/g'`
   EXEC=../$execn EXTOBJ=$files make -C runtime link
else
   echo -e "Analysis [FAILED]\n"
fi

