#!/bin/sh

if [ -z "$1" ] ; then
   echo "Usage: ./run.sh exec_out_name path ...CPP args" 
   exit -1
fi   
if [ -z "$2" ] ; then
   echo "Usage: ./run.sh exec_out_name path ...CPP args" 
   exit -1
fi

#WARNING: ensure that runtime.c is compiled with
#         the same debug flags as src
DEBUG_FLAG=`make -C runtime print_debug_flag`
rm -r -f tmp 
mkdir -p tmp/src 
arg1="$2/*.c" 
execn=$1
#eat first two arguments
shift
shift
rm -f gcc-log.txt
echo "Preprocessing files"
for f in $arg1
do
echo "Processing file: $f"
echo "CPP options: $@"
cat runtime/runtime.h $f | gcc $@ $DEBUG_FLAG -E - > tmp/`basename $f`
echo "scripts/duppy tmp/`basename $f`" >> gcc-log.txt
done
echo -e "Preprocessing files [OK]\nDumping calls"
OCAMLRUNPARAM="b1" scripts/dump-calls.sh
echo -e "Dumping calls [OK]\nRunning the analysis\n"
OCAMLRUNPARAM="b1" ./deadlock.exe  -cg ciltrees/calls.cil $DEBUG
if [ $? -eq 0 ] ; then
   echo -e "Analysis [OK]\n"
   #grep -v "#line" ciltrees/src_pass2.c.txt > tmp/output.c 
   files=`ls -1 ciltrees/gen/ | awk '{printf "../ciltrees/gen/%s ", $0}' | sed 's/\.c/\.o/g'`
   EXEC=../$execn EXTOBJ=$files EXTFLAGS=$@ make -C runtime link
else
   echo -e "Analysis [FAILED]\n"
fi
