/* Authors: Prodromos Gerakios and Nikolaos Papaspyrou
 *
 * All rights reserved.
 */
#ifndef __RUNTIME_H__
#define __RUNTIME_H__
#include <pthread.h> 
//#define DEBUG


// SEQ is useless but it cannot be removed
typedef struct meta_info {
 enum {SIMPLE=0,PATH=1,CALL=-1,SEQ=-2} tag : 2; //tag
 enum {LOCK=1,UNLOCK=-1} type : 2; // VALID only when tag = SIMPLE
 enum {STACK=0,GLOBAL=1,HEAP=-2} mem : 2;// VALID only when tag = SIMPLE
 unsigned char has_parent: 1; // true is thee exists a parent node 
 unsigned char dummy : 1;
 unsigned char parent; // assumes a single array of nodes no more than 255..
                     // parent must be allocated before children (unsigned char)
 unsigned char parent_offset; // offset within parent array
 unsigned char size; // If TAG = SIMPLE size = parent_size
                     // otherwise size of "com" array 
} meta_info_t; 

//struct mypthread_mutex; 
//typedef struct mypthread_mutex mypthread_mutex_t;
typedef union kind {
     int stack_offset; //TAG = SEQ and KIND =  STACK
     struct mypthread_mutex * handle; //TAG= SEQ and KIND = GLOBAL or HEAP
     struct node *com; //TAG is PATH or SEQ -- sequence of paths
                       //  and simple elements or a path
                       //  element with multiple paths
 } kind_t; 

typedef  struct node {
  meta_info_t meta_info; // 4 bytes
  kind_t kind;           // sizeof(void *)
  const char *node_name;
} node_t;

//typedef unsigned long ulong;
typedef struct stack_node {
  struct stack_node * next;
  node_t *current; /*DO NOT CHANGE node_t here*/
  struct mypthread_mutex **locals;
} stack_node_t;

typedef struct mypthread_mutex {
  pthread_mutex_t mutex;
  char *name;
} mypthread_mutex_t;

#define EXTERN
extern __thread stack_node_t *stack;
extern int mypthread_mutex_lock (mypthread_mutex_t *lock);
//
extern int mypthread_cond_wait (pthread_cond_t *cond,
                                mypthread_mutex_t *mutex);

stack_node_t dummy___stack; /// HACK: force CIL to include stack_node_t

//the following must be undefined in runtime.c
#ifndef ___RUNTIME__
#define pthread_mutex_t mypthread_mutex_t
#define pthread_mutex_lock mypthread_mutex_lock
#define pthread_mutex_unlock mypthread_mutex_unlock
// condition variables
/*
*/
#define pthread_cond_wait mypthread_cond_wait
#endif

#endif
